var manifesturl = chrome.runtime.getURL('');
var storagedata = {}, action_interval = null, button_interval = null;

var formatbyte = function (s) {
  if (s >= Math.pow(2, 30)) return (s / Math.pow(2, 30)).toFixed(1) + "GB";
  if (s >= Math.pow(2, 20)) return (s / Math.pow(2, 20)).toFixed(1) + "MB";
  if (s >= Math.pow(2, 10)) return (s / Math.pow(2, 10)).toFixed(1) + "KB";
  return s + "B";
};

var insertbutton = function () {
  var action = function (a, b) {
    var link = document.getElementById("YDL-style");
    if (!link) {
      link = document.createElement("link");
      link.setAttribute("id", "YDL-style");
      link.setAttribute("type", "text/css");
      link.setAttribute("rel", "stylesheet");
      link.setAttribute("class", "YDL-button");
      link.setAttribute("href", manifesturl + "data/content_script/inject.css");
      var head = document.documentElement || document.head || document.querySelector("head");
      if (head) head.appendChild(link);
    }
    /*  */
    var button = document.createElement("div");
    button.setAttribute("class", a);
    button.setAttribute("type", "button");
    button.setAttribute("role", "button");
    button.setAttribute("id", "media-capture-button");
    button.setAttribute("title", "Download this video");
    /*  */
    var icon = document.createElement("div");
    icon.setAttribute("id", "media-capture-img");
    icon.setAttribute("class", b + "ytd-toggle-button-renderer");
    icon.style.background = "url(" + manifesturl + "data/content_script/icons/download.png" + ") no-repeat center center";
    icon.style.backgroundSize = "16px";
    /*  */
    button.appendChild(icon);
    return button;
  };
  /*  */
  var manager = document.querySelector("#page-manager");
  var sentiment = document.querySelector("#watch8-sentiment-actions");
  var secondary = document.querySelector("#watch8-secondary-actions");
  /*  */
  if (manager) { // #1
    var container = manager.querySelector('#menu-container');
    if (container) {
      var buttons = container.querySelector('#top-level-buttons');
      if (buttons) {
        var button = action("style-scope ytd-menu-renderer force-icon-button style-text", "style-scope ");
        buttons.insertBefore(button, buttons.firstChild);
        return button;
      }
    }
  } else if (sentiment) { // #2
    var button = action("media-capture-button-old", '');
    sentiment.insertBefore(button, sentiment.firstChild);
    return button;
  } else if (secondary) { // #3
    var button = action("media-capture-button-old", '');
    secondary.insertBefore(button, secondary.lastChild);
    return button;
  } else return null;
};

var menu = {
  "ul": null,
  "hide": function () {
    var tmp = document.getElementById("media-capture-ul");
    if (tmp) tmp.parentNode.removeChild(tmp);
    menu.ul = null;
  },
  "show": function (downloadlist) {
    menu.ul = document.createElement("ul");
    menu.ul.setAttribute("id", "media-capture-ul");
    menu.ul.setAttribute("class", "YDL-dropdown-material");
    /*  */
    var addmenuitem = function (o, i) {
      var li = document.createElement("li");
      var span0 = document.createElement("span");
      var span1 = document.createElement("span");
      var span2 = document.createElement("span");
      var span3 = document.createElement("span");
      var span4 = document.createElement("span");
      var button = document.createElement("button");
      /*  */
      li.setAttribute("role", "menuitem");
      button.setAttribute("type", "button");
      button.setAttribute("class", "YDL-menuitem-material");
      button.setAttribute("data-orientation", "horizontal");
      button.setAttribute("_url", (o.url + "&title=" + o.title.toLowerCase()));
      button.setAttribute("_filename", (o.title.toLowerCase() + '.' + o.container));
      button.addEventListener("click", function () {background.send("page:download", {"url": this.getAttribute("_url"), "filename": this.getAttribute("_filename")})});
      /*  */
      span0.style.width = "32px";
      span0.style.height = "14px";
      span0.style.background = 'url(' + manifesturl + "data/content_script/icons/" + (o.info[4] === 'v' ? "video" : (o.info[4] === 'a' ? "audio" : "media")) + ".png) no-repeat center center";
      span0.style.backgroundSize = "14px";
      /*  */
      var str_video = o.info[1] ? (o.info[0] ? "Video " + o.info[0].toUpperCase() : 'N/A') + (o.info[1] ? ' :: ' + o.info[1] + "p" : 'N/A') : 'Video N/A';
      var str_audio = o.info[3] ? (o.info[2] ? "Audio " + o.info[2].toUpperCase() : 'N/A') + (o.info[3] ? " :: " + o.info[3] + "kbps" : 'N/A') : 'Audio N/A';
      /*  */
      span0.style.minWidth = "24px";
      span1.style.minWidth = "24px";
      span2.style.minWidth = "164px";
      span3.style.minWidth = "164px";
      span4.setAttribute("YDL-d-u", o.url);
      /*  */
      span1.textContent = (i + 1) + '.';
      if (o.info[1]) {
        span2.textContent = str_video;
        span3.textContent = str_audio;
      } else if (o.info[3]) {
        span2.textContent = str_audio;
        span3.textContent = str_video;
      }
      span4.textContent = "? MB";
      /*  */
      span0.style.display = "inline-block";
      span1.style.display = "inline-block";
      span2.style.display = "inline-block";
      span3.style.display = "inline-block";
      span4.style.display = "inline-block";
      /*  */
      span0.style.verticalAlign = "middle";
      span1.style.verticalAlign = "middle";
      span2.style.verticalAlign = "middle";
      span3.style.verticalAlign = "middle";
      span4.style.verticalAlign = "middle";
      /*  */
      span0.style.color = o.info[4] === 'v' ? "#E62117" : (o.info[4] === 'a' ? "#4374E0" : "#555");
      span1.style.color = o.info[4] === 'v' ? "#E62117" : (o.info[4] === 'a' ? "#4374E0" : "#555");
      span2.style.color = o.info[4] === 'v' ? "#E62117" : (o.info[4] === 'a' ? "#4374E0" : "#555");
      span3.style.color = o.info[4] === 'v' ? "#E62117" : (o.info[4] === 'a' ? "#4374E0" : "#555");
      span4.style.color = o.info[4] === 'v' ? "#E62117" : (o.info[4] === 'a' ? "#4374E0" : "#555");
      /*  */
      button.appendChild(span0);
      button.appendChild(span1);
      button.appendChild(span2);
      button.appendChild(span3);
      button.appendChild(span4);
      li.appendChild(button);
      menu.ul.appendChild(li);
      /*  */
      window.setTimeout(function () {background.send("page:get-video-size", {"url": o.url})}, 300);
    };
    /*  */
    downloadlist.forEach(addmenuitem);
    var rect = document.getElementById("media-capture-button").getClientRects()[0];
    var style = "top: " + (rect.top + window.scrollY + 27) + "px; left:" + (rect.left + window.scrollX) + "px; position: absolute;";
    menu.ul.setAttribute("style", style);
    document.body.appendChild(menu.ul);
  }
};

var getdownloadurl = function () {
  var icon = document.getElementById("media-capture-img");
  if (icon) {
    background.send("page:catch-download-url", {"url": document.location.href});
    icon.style.background = "url(" + manifesturl + "data/content_script/icons/loader.gif" + ") no-repeat center center";
    icon.style.backgroundSize = "16px";
  }
};

var action = function () {
  if (button_interval) window.clearInterval(button_interval);
  var valid = document.getElementById("media-capture-button");
  if (!valid) {
    button_interval = window.setInterval(function () {
      var button = insertbutton();
      if (button) {
        window.addEventListener("click", menu.hide, false);
        if (button_interval) window.clearInterval(button_interval);
        button.addEventListener("click", function () {menu.ul ? menu.hide() : getdownloadurl()}, false);
      }
    }, 300);
  }
};

if (action_interval) window.clearInterval(action_interval);
action_interval = window.setInterval(action, 1000);

background.receive("page:make-dropdown-menu", function (o) {
  var icon = document.getElementById("media-capture-img");
  if (icon && o.menu.length > 0) {
    icon.style.background = "url(" + manifesturl + "data/content_script/icons/download.png" + ") no-repeat center center";
    icon.style.backgroundSize = "16px";
    menu.show(o.menu);
  }
});

background.receive("page:set-video-size", function (e) {
  var spans = document.querySelectorAll("span[YDL-d-u]");
  for (var i = 0; i < spans.length; i++) {
    var span = spans[i];
    if (span.getAttribute("YDL-d-u") === e.size[0]) {
      span.textContent = ' ' + formatbyte(e.size[1]);
      break;
    }
  }
});
