/*
  Parts of this code is inspired from the following:
  [1] http://userscripts-mirror.org/scripts/review/25105
  [2] https://gist.github.com/clonezer/7559013#file-command-js
  [3] https://gist.github.com/tborychowski/a3769eb30e05c58461f6
  [4] https://openuserjs.org/scripts/sahilx10/youtubevideo_download/source
  [5] https://greasyfork.org/en/scripts/1317-download-youtube-videos-as-mp4/code
*/

var _array = [
  ['13',  '3gp',  'N/A',  'aac', null, null],
  ['17',  '3gp',  '144',  'aac', 24,   null],
  ['36',  '3gp',  '240',  'aac', 38,   null],
  ['5',   'flv',  '240',  'mp3', 64,   null],
  ['83',  'mp4',  '240',  'aac', 96,   null],
  ['6',   'flv',  '270',  'mp3', 64,   null],
  ['35',  'flv',  '280',  'aac', 128,  null],
  ['34',  'flv',  '360',  'aac', 128,  null],
  ['18',  'mp4',  '360',  'aac', 96,   null],
  ['82',  'mp4',  '360',  'aac', 96,   null],
  ['43',  'webm', '360',  'ogg', 128,  null],
  ['100', 'webm', '360',  'ogg', 128,  null],
  ['101', 'webm', '360',  'ogg', 192,  null],
  ['59',  'mp4',  '480',  'aac', 128,  null],
  ['78',  'mp4',  '480',  'aac', 128,  null],
  ['44',  'webm', '480',  'ogg', 128,  null],
  ['85',  'mp4',  '520',  'aac', 152,  null],
  ['120', 'flv',  '720',  'aac', 128,  null],
  ['22',  'mp4',  '720',  'aac', 192,  null],
  ['84',  'mp4',  '720',  'aac', 192,  null],
  ['102', 'webm', '720',  'ogg', 192,  null],
  ['45',  'webm', '720',  'ogg', 192,  null],
  ['37',  'mp4',  '1080', 'aac', 192,  null],
  ['46',  'webm', '1080', 'ogg', 192,  null],
  ['38',  'mp4',  '3072', 'aac', 192,  null],
  ['139', 'm4a',   null,  'aac', 38,   'a'],
  ['249', 'webm',  null,  'opus', 50,  'a'],
  ['250', 'webm',  null,  'opus', 70,  'a'],
  ['171', 'webm',  null,  'ogg', 128,  'a'],
  ['140', 'm4a',   null,  'aac', 128,  'a'],
  ['251', 'webm',  null,  'opus', 160, 'a'],
  ['172', 'webm',  null,  'ogg', 192,  'a'],
  ['141', 'm4a',   null,  'aac', 256,  'a'],
  ['278', 'webm', '144',  null,  null, 'v'],
  ['160', 'mp4',  '144',  null,  null, 'v'],
  ['242', 'webm', '240',  null,  null, 'v'],
  ['133', 'mp4',  '240',  null,  null, 'v'],
  ['243', 'webm', '360',  null,  null, 'v'],
  ['134', 'mp4',  '360',  null,  null, 'v'],
  ['246', 'webm', '480',  null,  null, 'v'],
  ['245', 'webm', '480',  null,  null, 'v'],
  ['244', 'webm', '480',  null,  null, 'v'],
  ['135', 'mp4',  '480',  null,  null, 'v'],
  ['302', 'webm', '720',  null,  null, 'v'],
  ['247', 'webm', '720',  null,  null, 'v'],
  ['298', 'mp4',  '720',  null,  null, 'v'],
  ['136', 'mp4',  '720',  null,  null, 'v'],
  ['303', 'webm', '1080', null,  null, 'v'],
  ['248', 'webm', '1080', null,  null, 'v'],
  ['299', 'mp4',  '1080', null,  null, 'v'],
  ['137', 'mp4',  '1080', null,  null, 'v'],
  ['308', 'webm', '1440', null,  null, 'v'],
  ['271', 'webm', '1440', null,  null, 'v'],
  ['264', 'mp4',  '1440', null,  null, 'v'],
  ['313', 'webm', '2160', null,  null, 'v'],
  ['272', 'webm', '2160', null,  null, 'v'],
  ['315', 'webm', '2160', null,  null, 'v'],
  ['138', 'mp4',  '2160', null,  null, 'v'],
  ['266', 'mp4',  '2160', null,  null, 'v']
];

var videoFormatInfo = {};
var videoFormatType = {};
var videoFormatOrder = [];
var decodedRuleArray = [];
var youtubeDownloadArray = [];
var USWID = "YDL-usw-element";
var isDecodeRuleUpdated = false;

for (var i = 0; i < _array.length; i++) videoFormatInfo[_array[i][0]] = [_array[i][1], _array[i][2], _array[i][3], _array[i][4], _array[i][5]];
for (var id in videoFormatInfo) videoFormatType[id] = videoFormatInfo[id][0];
for (var i = 0; i < _array.length; i++) videoFormatOrder.push(_array[i][0]);

var createhiddenpre = function (id) {
  var pre = document.createElement('pre');
  pre.setAttribute('style', 'display:none');
  pre.setAttribute('id', id);
  document.body.appendChild(pre);
  return pre;
};

var httprequest = function (details) {
  var xhr = new XMLHttpRequest();
  xhr.onload = function () {if (details['onload']) details['onload'](xhr)}
  xhr.onerror = function () {if (details['onload']) details['onload'](null)};
  xhr.open(details.method, details.url, true);
  xhr.send();
};
/*  */
var injectpagescript = function () {
  var code =
  'if (ytplayer && ytplayer.config && ytplayer.config.args)' +
  '{' +
    'document.getElementById("' + USWID + '2").appendChild(' +
      'document.createTextNode(' +
        '\'"js":"\'+ytplayer.config.assets.js+\'",' +
        '"dashmpd":"\'+ytplayer.config.args.dashmpd+\'",' +
        '"video_id":"\'+ytplayer.config.args.video_id+\'",' +
        '"adaptive_fmts":"\'+ytplayer.config.args.adaptive_fmts+\'",' +
        '"url_encoded_fmt_stream_map":"\'+ytplayer.config.args.url_encoded_fmt_stream_map+\'"\'' +
        ')' +
      ')' +
  '}';

  var script = document.getElementById("YDL-usw-script");
  if (script) script.parentNode.removeChild(script);
  script = document.createElement('script');
  script.setAttribute("id", "YDL-usw-script");
  script.type = 'application/javascript';
  script.textContent = code;
  document.body.appendChild(script);
  /*  */
  window.setTimeout(function () {
    var script = document.getElementById("YDL-usw-script");
    if (script) script.parentNode.removeChild(script);
  }, 3000);
};
/*  */
var regExpMatch = function (text, regexp) {
  var _matches = text.match(regexp);
  return _matches && _matches.length ? _matches[1] : null;
};
/*  */
var isInteger = function (n) {return (typeof n === 'number' && n % 1 == 0)};
var isString = function (s) {return (typeof s === 'string' || s instanceof String)};
/*  */
var _action = function (YPI) {
  //console.error("action", YPI);
  decodedRuleArray = [];
  youtubeDownloadArray = [];
  isDecodeRuleUpdated = false;
  var isSignatureUpdatingStarted = false;
  var videoID = null, videoFormats = null, videoAdaptFormats = null, videoManifestURL = null, scriptURL = null;
  /*  */
  var getDecodeRules = function (rules) {
    var storageCode = storagedata.code;
    if (storageCode && storageCode !== 'error' && isSignatureCodeValid(storageCode)) {
      var arr = storageCode.split(',');
      for (var i = 0; i < arr.length; i++) arr[i] = parseInt(arr[i], 10);
      rules = arr;
    }
    return rules;
  };
  /*  */
  var isSignatureCodeValid = function (arr) {
    if (!arr) return false;
    if (arr === 'error') return true;
    arr = arr.split(',');
    for (var i = 0; i < arr.length; i++) {if (!isInteger(parseInt(arr[i], 10))) return false}
    return true;
  };
  /*  */
  var decryptSignature = function (sig) {
    function swap(a, b) {
      var c = a[0];
      a[0] = a[b % a.length];
      a[b] = c;
      return a;
    }
    function decode(sig, arr) {
      if (!isString(sig)) return null;
      var sigA = sig.split('');
      for (var i = 0; i < arr.length; i++) {
        var act = arr[i];
        if (!isInteger(act)) return null;
        sigA = (act > 0) ? swap(sigA, act) : ((act == 0) ? sigA.reverse() : sigA.slice(-act));
      }
      var _result = sigA.join('');
      return _result;
    }
    if (sig == null) return '';
    var arr = decodedRuleArray;
    if (arr) {
      var sig2 = decode(sig, arr);
      if (sig2) return sig2;
    } else {
      background.send("page:storage-url", {"url": ''});
      background.send("page:storage-code", {"code": ''});
    }
    return sig;
  };
  /*  */
  var findSignature = function (sourceCode) {
    var signatureFunctionName =
      regExpMatch(sourceCode, /\.sig\s*\|\|\s*([a-zA-Z0-9_$][\w$]*)\(/) ||
      regExpMatch(sourceCode, /signature.*\.set\([^,],\s*([a-zA-Z0-9_$]*)\(/) ||
      regExpMatch(sourceCode, /\.set\s*\("signature"\s*,\s*([a-zA-Z0-9_$][\w$]*)\(/) ||
      regExpMatch(sourceCode, /\.signature\s*=\s*([a-zA-Z_$][\w$]*)\([a-zA-Z_$][\w$]*\)/) ||
      regExpMatch(sourceCode, /([^\s};]*)\s*=\s*function\s*\([^,]\)[^}]*\.split\(["']{2}\)[^}]*\.join\(['"]{2}\)/);
    /*  */
    if (signatureFunctionName === null) return background.send("page:storage-code", {"code": 'error #1'});
    signatureFunctionName = signatureFunctionName.replace('$', '\\$');
    /*  */
    var regCode1 = new RegExp(signatureFunctionName + '\\=\\s*function\\([\\w$]*\\)\\s*{[\\w$]*=[\\w$]*\\.split\\(""\\);(.+);return [\\w$]*\\.join');
    var regCode2 = new RegExp('function \\s*' + signatureFunctionName + '\\s*\\([\\w$]*\\)\\s*{[\\w$]*=[\\w$]*\\.split\\(""\\);(.+);return [\\w$]*\\.join');
    var functionCode = regExpMatch(sourceCode, regCode1) || regExpMatch(sourceCode, regCode2);
    /*  */
    if (functionCode === null) return background.send("page:storage-code", {"code": 'error #2'});
    var reverseFunctionName = regExpMatch(sourceCode,/([\w$]*)\s*:\s*function\s*\(\s*[\w$]*\s*\)\s*{\s*(?:return\s*)?[\w$]*\.reverse\s*\(\s*\)\s*}/);
    if (reverseFunctionName) reverseFunctionName = reverseFunctionName.replace('$', '\\$');
    var sliceFunctionName = regExpMatch(sourceCode,/([\w$]*)\s*:\s*function\s*\(\s*[\w$]*\s*,\s*[\w$]*\s*\)\s*{\s*(?:return\s*)?[\w$]*\.(?:slice|splice)\(.+\)\s*}/);
    if (sliceFunctionName) sliceFunctionName = sliceFunctionName.replace('$', '\\$');
    var regSlice = new RegExp('\\.(?:' + 'slice' + (sliceFunctionName ? '|' + sliceFunctionName : '') + ')\\s*\\(\\s*(?:[a-zA-Z_$][\\w$]*\\s*,)?\\s*([0-9]+)\\s*\\)');
    var regReverse = new RegExp('\\.(?:' + 'reverse' + (reverseFunctionName ? '|' + reverseFunctionName : '') + ')\\s*\\([^\\)]*\\)');
    var regSwap = new RegExp('[\\w$]+\\s*\\(\\s*[\\w$]+\\s*,\\s*([0-9]+)\\s*\\)');
    var regInline = new RegExp('[\\w$]+\\[0\\]\\s*=\\s*[\\w$]+\\[([0-9]+)\\s*%\\s*[\\w$]+\\.length\\]');
    var functionCodePieces = functionCode.split(';');
    var decodeArray = [];
    /*  */
    for (var i = 0; i < functionCodePieces.length; i++) {
      functionCodePieces[i] = functionCodePieces[i].trim();
      var codeLine = functionCodePieces[i];
      if (codeLine.length > 0) {
        var arrSlice = codeLine.match(regSlice);
        var arrReverse = codeLine.match(regReverse);
        if (arrSlice && arrSlice.length >= 2) {
          var slice = parseInt(arrSlice[1], 10);
          if (isInteger(slice)) decodeArray.push(-slice);
          else return background.send("page:storage-code", {"code": 'error #3'});
        }
        else if (arrReverse && arrReverse.length >= 1) {decodeArray.push(0)}
        else if (codeLine.indexOf('[0]') >= 0) {
          if (i + 2 < functionCodePieces.length && functionCodePieces[i + 1].indexOf('.length') >= 0 && functionCodePieces[i + 1].indexOf('[0]') >= 0) {
            var inline = regExpMatch(functionCodePieces[i + 1], regInline);
            inline = parseInt(inline, 10);
            decodeArray.push(inline);
            i += 2;
          } else return background.send("page:storage-code", {"code": 'error #4'});
        }
        else if (codeLine.indexOf(',') >= 0) {
          var swap = regExpMatch(codeLine, regSwap);
          swap = parseInt(swap, 10);
          if (isInteger(swap) && swap > 0) {decodeArray.push(swap)}
          else return background.send("page:storage-code", {"code": 'error #5'});
        } else return background.send("page:storage-code", {"code": 'error #6'});
      }
    }
    /*  */
    if (decodeArray) {
      background.send("page:storage-url", {"url": scriptURL});
      background.send("page:storage-code", {"code": decodeArray.toString()});
      decodedRuleArray = decodeArray;
    }
  };
  /*  */
  var fetchsignaturescript = function (scriptURL) {
    var storageURL = storagedata.url;
    var storageCode = storagedata.code;
    if (!(/,0,|^0,|,0$|\-/.test(storageCode))) storageCode = null;
    if (storageCode && isSignatureCodeValid(storageCode) && storageURL && scriptURL.replace(/^https?/i, '') === storageURL.replace(/^https?/i, '')) return;
    /*  */
    try {
      isSignatureUpdatingStarted = true;
      httprequest({"method": 'GET', "url": scriptURL, "onload": function (response) {
        if (response) {
          if (response.responseText) {
            findSignature(response.responseText);
          }
        }
      }});
    } catch (e) {}
  };

  /* method #1 */
  if (YPI && YPI.scriptURL) {
    //console.error("method #1");
    videoID = YPI.videoID;
    scriptURL = YPI.scriptURL;
    videoFormats = YPI.videoFormats;
    videoManifestURL = YPI.videoManifestURL;
    videoAdaptFormats = YPI.videoAdaptFormats;
  }

  /* method #2 */
  if (videoID === null) {
    //console.error("method #2");
    if (window.ytplayer) {
      if (window.ytplayer.config) {
        if (window.ytplayer.config.assets) scriptURL = window.ytplayer.config.assets.js;
        if (window.ytplayer.config.args) {
          var args = window.ytplayer.config.args;
          if (args) {
            videoID = args['video_id'];
            videoManifestURL = args['dashmpd'];
            videoAdaptFormats = args['adaptive_fmts'];
            videoFormats = args['url_encoded_fmt_stream_map'];
          }
        }
      }
    }
  }

  /* method #3 */
  if (videoID === null) {
    //console.error("method #3");
    var _content = document.body.textContent;
    if (_content !== null) {
      videoID = regExpMatch(_content, /\"video_id\":\s*\"([^\"]+)\"/);
      videoFormats = regExpMatch(_content, /\"url_encoded_fmt_stream_map\":\s*\"([^\"]+)\"/);
      videoAdaptFormats = regExpMatch(_content, /\"adaptive_fmts\":\s*\"([^\"]+)\"/);
      videoManifestURL = regExpMatch(_content, /\"dashmpd\":\s*\"([^\"]+)\"/);
      if (scriptURL === null) {
        scriptURL = regExpMatch(_content, /\"js\":\s*\"([^\"]+)\"/);
        if (scriptURL) scriptURL = scriptURL.replace(/\\/g, '');
      }
    }
  }

  /* method #4 */
  if (videoID === null) {
    //console.error("method #4");
    var _content = document.body.textContent;
    if (_content !== null) {
      videoID = regExpMatch(_content, new RegExp('\\"video_id\\":\s*\\"([^\"]+)\\"'));
      videoFormats = regExpMatch(_content, new RegExp('\\"url_encoded_fmt_stream_map\\":\s*\\"([^\"]+)\\"'));
      videoAdaptFormats = regExpMatch(_content, new RegExp('\\"adaptive_fmts\\":\s*\\"([^\"]+)\\"'));
      videoManifestURL = regExpMatch(_content, new RegExp('\\"dashmpd\\":\s*\\"([^\"]+)\\"'));
      if (scriptURL === null) {
        scriptURL = regExpMatch(_content, new RegExp('\\"js\\":\s*\\"([^\"]+)\\"'));
        if (scriptURL) scriptURL = scriptURL.replace(/\\/g, '');
      }
    }
  }

  /* decision */
  if (videoID === null || videoFormats === null || (videoID && videoID.length === 0) || (videoFormats && videoFormats.length === 0)) {
    alert("An error has occurred! please reload the page and try again.");
  }

  if (!isDecodeRuleUpdated) {
    decodedRuleArray = getDecodeRules(decodedRuleArray);
    isDecodeRuleUpdated = true;
  }

  if (scriptURL) {
    if (scriptURL.indexOf('//') === 0) scriptURL = document.location.protocol + scriptURL;
    else if (scriptURL.indexOf('/') === 0) scriptURL = document.location.protocol + "//www.youtube.com" + scriptURL;
    else scriptURL = document.location.protocol + "//www.youtube.com" + scriptURL.replace(/\\/g, '');
    fetchsignaturescript(scriptURL);
  }

  var sep1 = '%2C', sep2 = '%26', sep3 = '%3D';
  if (videoFormats.indexOf(',') > -1) {
    sep1 = ',';
    sep2 = (videoFormats.indexOf('&') > -1) ? '&' : '\\u0026';
    sep3 = '=';
  }
  if (videoAdaptFormats) videoFormats = videoFormats + sep1 + videoAdaptFormats;

  /* make URLs */

  var videoURL = new Array();
  var videoSignature = new Array();
  var videoTitle = document.title || 'video';
  var videoFormatsGroup = videoFormats.split(sep1);
  videoTitle = videoTitle.replace(/\s*\-\s*YouTube$/i, '').replace(/[\~\!\@\#\%\&\^\$\*\_\-\+\=\'\"\.\,\:\;\?\<\>\\\|\//{/}\(\)]/g, '').replace(/^\s+|\s+$/g, '').replace(/\.+$/g, '').replace(/\s\s+/g, ' ').replace(/\s/g, '-');
  /*  */
  for (var i = 0; i < videoFormatsGroup.length; i++) {
    var videoFormatsElem = videoFormatsGroup[i].split(sep2);
    var videoFormatsPair = new Array();
    for (var j = 0; j < videoFormatsElem.length; j++) {
      var pair = videoFormatsElem[j].split(sep3);
      if (pair.length == 2) videoFormatsPair[pair[0]] = pair[1];
    }
    if (videoFormatsPair['url'] == null) continue;
    var url = unescape(unescape(videoFormatsPair['url'])).replace(/\\\//g, '/').replace(/\\u0026/g, '&');
    if (videoFormatsPair['itag'] == null) continue;
    var itag = videoFormatsPair['itag'];
    var sig = videoFormatsPair['sig'] || videoFormatsPair['signature'];
    if (sig) {
      url = url + '&signature=' + sig;
      videoSignature[itag] = null;
    } else if (videoFormatsPair['s']) {
      url = url + '&signature=' + decryptSignature(videoFormatsPair['s']);
      videoSignature[itag] = videoFormatsPair['s'];
    }
    if (url.toLowerCase().indexOf('ratebypass') == -1) url = url + '&ratebypass=yes';
    if (url.toLowerCase().indexOf('http') == 0) videoURL[itag] = url + '&title=' + videoTitle;
  }
  /*  */
  for (var i = 0; i < videoFormatOrder.length; i++) {
    var format = videoFormatOrder[i];
    if (videoURL[format] && videoFormatInfo[format]) {
      youtubeDownloadArray.push({
        "format": format,
        "title": videoTitle,
        "url": videoURL[format],
        "sig": videoSignature[format],
        "info": videoFormatInfo[format],
        "container": videoFormatInfo[format][0],
        "resolution": videoFormatInfo[format][1]
      });
    }
  }
  /*  */
  background.send("page:download-url-result", {"result": youtubeDownloadArray});
};

background.send("page:load");

background.receive("page:storage", function (data) {
  storagedata.code = data.code;
  storagedata.url = data.url;
});

background.receive("page:action", function () {
  var result = {};
  const ID = window.location.search.split('v=')[1];
  var buffer = document.getElementById(USWID + '2');
  buffer ? buffer.textContent = '' : buffer = createhiddenpre(USWID + '2');
  const videoID = ID.indexOf('&') !== -1 ? ID.substring(0, ID.indexOf('&')) : ID;
  /*  */
  injectpagescript();
  /*  */
  var content = buffer.textContent;
  if (content) {
    result.scriptURL = regExpMatch(content, /\"js\":\s*\"([^\"]+)\"/);
    result.videoID = regExpMatch(content, /\"video_id\":\s*\"([^\"]+)\"/);
    result.videoManifestURL = regExpMatch(content, /\"dashmpd\":\s*\"([^\"]+)\"/);
    result.videoAdaptFormats = regExpMatch(content, /\"adaptive_fmts\":\s*\"([^\"]+)\"/).replace(/&amp;/g, '\\u0026');
    result.videoFormats = regExpMatch(content, /\"url_encoded_fmt_stream_map\":\s*\"([^\"]+)\"/).replace(/&amp;/g, '\\u0026');
  }
  /*  */
  if (!result.videoID || (result.videoID && result.videoID !== videoID)) {
    httprequest({"method": 'GET', "url": document.location.href, "onload": function (response) {
      if (response) {
        if (response.responseText) {
          var content = response.responseText;
          if (content) {
            result.videoID = videoID;
            result.scriptURL = regExpMatch(content, /"js":\s*"([^"]+)"/);
            result.videoManifestURL = regExpMatch(content, /"dashmpd":\s*"([^"]+)"/);
            result.videoAdaptFormats = regExpMatch(content, /adaptive_fmts"\:\s*"([^"]*)/);
            result.videoFormats = regExpMatch(content, /url_encoded_fmt_stream_map":\s*"([^"]*)/);
            _action(result);
          } else _action(null);
        } else _action(null);
      } else _action(null);
    }});
  } else _action(result);
});
