function concat(a, d) {
    return a ? d ? a + " " + d : a : d || ""
}

function throttleAll(a, d, c) {
    var b = 0;
    return function() {
        var e = +new Date;
        e - b < d || (b = e, a.apply(c, arguments))
    }
}

function generateUseClipTypeFunctionForShortcut(a) {
    return function() {
        useClipType({
            clipType: a
        })
    }
}

function onUserChange() {
    if (saveEnabled = !1, previousAccount.id) {
        var a = previousAccount.id + previousAccount.subpart;
        accountDataCache[a] = accountDataCache[a] || {};
        accountDataCache[a].selectedNotebook = notebookSelector.getSelectedNotebook();
        accountDataCache[a].selectedTags = tagSelector.getTags()
    }
    var d = accountSelector.getSelectedAccount(),
        c = d.userInfo.userId,
        b = d.selectedSubpart;
    previousAccount.id = c;
    previousAccount.subpart = b;
    var e = c + b;
    accountDataCache[e] || (accountDataCache[e] = {});
    var f = {};
    Promise.resolve().then(function() {
        return platform.channel.sendMessage("getFilingInfo", {
            userId: c,
            selectedSubpart: b
        })["catch"](function(a) {
            return log.error(a), {}
        })
    }).then(function(a) {
        return f = a, platform.channel.sendMessage("getSmartFilingInfo", {
            userId: c,
            selectedSubpart: b,
            text: recommendations.text,
            url: recommendations.url,
            pendingNoteKey: pendingNoteKey
        })["catch"](function(a) {
            return log.error(a), {}
        })
    }).then(function(a) {
        return a.info && (f.smartNotebook = a.info.smartNotebook, f.smartTags = a.info.smartTags), refreshNotebooks(d, f, !0)
    }).then(function() {
        return platform.channel.sendMessage("getTags", {
            userId: c,
            selectedSubpart: b
        })
    }).then(function(a) {
        tagSelector.setTags(a);
        accountDataCache[e].selectedTags && accountDataCache[e].selectedTags.length ? tagSelector.selectTags(accountDataCache[e].selectedTags) : f.alwaysTags && 0 < f.alwaysTags.length ? tagSelector.selectTags(f.alwaysTags) : f.smartTags && 0 < f.smartTags.length && tagSelector.selectTags(f.smartTags);
        updateTagsInput()
    })["catch"](function(a) {
        log.error("OnUserChange error");
        log.error(a);
        saveEnabled = !0
    })
}

function cloneASTElement(a) {
    return createASTElement(a.tag, a.attrsList.slice(), a.parent)
}

function renderClass(a, d) {
    return isDef(a) || isDef(d) ? concat(a, stringifyClass(d)) : ""
}

function isTextTag(a) {
    return "1" === a.tag || "style" === a.tag
}

function locateNode(a) {
    return !a.componentInstance || a.data && a.data.transition ? a : locateNode(a.componentInstance._vnode)
}

function mergeHook$1(a, d) {
    return function(c, b, e, f) {
        a(c, b, e, f);
        d(c, b, e, f)
    }
}

function deleteData() {
    if (is_ie) saveData("", "delete");
    else if (window.sessionStorage) try {
        sessionStorage.removeItem("Discuz!")
    } catch (a) {}
}

function setKeyboardHandlers(a, d, c) {
    if (shortcutsEnabled = a.enabled, a.handlers) {
        d = {};
        for (var b in a.handlers)
            for (var e = 0; e < a.handlers[b].length; e++) switch (-1 < ["expandArticleShortcut", "contractArticleShortcut", "moveArticleUpShortcut", "moveArticleDownShortcut"].indexOf(b) ? d[a.handlers[b][e]] = function(a, b) {
                "function" == typeof shortcutHandlers[a] && 0 > ["INPUT", "TEXTAREA"].indexOf(b.nodeName) && "true" !== b.contentEditable && shortcutHandlers[a](a, b)
            } : d[a.handlers[b][e]] = function(a, b) {
                shortcutsEnabled && "function" ==
                    typeof shortcutHandlers[a] && 0 > ["INPUT", "TEXTAREA"].indexOf(b.nodeName) && "true" !== b.contentEditable && shortcutHandlers[a](a, b)
            }, b) {
                case "closeWebClipperShortcut":
                    shortcutHandlers[a.handlers[b][e]] = function(a) {
                        handleEscape({
                            code: a
                        })
                    };
                    d[a.handlers[b][e]] = function(a, b) {
                        "function" == typeof shortcutHandlers[a] && shortcutHandlers[a](a, b)
                    };
                    break;
                case "toggleAccountShortcut":
                    shortcutHandlers[a.handlers[b][e]] = toggleAccount;
                    break;
                case "previewArticleShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("article");
                    break;
                case "previewFullPageShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("fullPage");
                    break;
                case "previewUrlShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("url");
                    break;
                case "selectionModeShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("selection");
                    break;
                case "takeScreenshotShortcut":
                    EDGE || (shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("screenshot"));
                    break;
                case "clearlyShortcut":
                    shortcutHandlers[a.handlers[b][e]] =
                        generateUseClipTypeFunctionForShortcut("clearly");
                    break;
                case "pdfShortcut":
                    EDGE || (shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("pdf"));
                    break;
                case "emailShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseClipTypeFunctionForShortcut("email");
                    break;
                case "selectNotebookShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateGeneralFunctionForShortcut(openNotebook);
                    break;
                case "addTagsShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateGeneralFunctionForShortcut(openTags);
                    break;
                case "saveShortcut":
                    shortcutHandlers[a.handlers[b][e]] = function() {
                        "" !== notebookSelector.getCreateNewNotebookValue() ? notebookSelector.saveNewNotebook() : this.body.classList.contains("skitchWaiting") ? gekco.sendToExtension({
                            name: "bounce",
                            message: {
                                name: "captureScreen"
                            }
                        }) : save()
                    };
                    break;
                case "minimizeClipperShortcut":
                    shortcutHandlers[a.handlers[b][e]] = toggleMinimizeClipper;
                    break;
                case "arrowShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "shapes",
                        subtool: "arrow"
                    });
                    break;
                case "textShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "text"
                    });
                    break;
                case "rectangleShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "shapes",
                        subtool: "rectangle"
                    });
                    break;
                case "roundedRectangleShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "shapes",
                        subtool: "roundedRectangle"
                    });
                    break;
                case "ellipseShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "shapes",
                        subtool: "ellipse"
                    });
                    break;
                case "lineShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "shapes",
                        subtool: "line"
                    });
                    break;
                case "markerShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "marker"
                    });
                    break;
                case "highlighterShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "highlighter"
                    });
                    break;
                case "stampShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "stamps"
                    });
                    break;
                case "pixelateShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "pixelate"
                    });
                    break;
                case "cropShortcut":
                    shortcutHandlers[a.handlers[b][e]] = generateUseSkitchToolFunctionForShortcut({
                        tool: "crop"
                    });
                    break;
                default:
                    shortcutHandlers[a.handlers[b][e]] = function(a) {
                        gekco.sendToExtension({
                            name: "bounce",
                            message: {
                                name: "duplicateKeyboardShortcut",
                                code: a
                            }
                        })
                    }
            }
        gekco.addKeyboardHandlers(d)
    }
    c && "function" == typeof c && c()
}

function setWindowTitle(a) {
    a && a.trim() ? this.title = a.trim() : this.title = gekco.i18n.getMessage("share")
}

function callHook(a, d) {
    var c = a.$options[d];
    if (c)
        for (var b = 0, e = c.length; b < e; b++) try {
            c[b].call(a)
        } catch (f) {}
    a._hasHookEvent && a.$emit("hook:" + d)
};